package javax.naming;

import java.io.Serializable;

public abstract class RefAddr implements Serializable
{
    protected String addrType;
    private static final long serialVersionUID = -1468165120479154358L;
    
    protected RefAddr(String addrType) {
        this.addrType = addrType;
    }
    
    public String getType() {
        return this.addrType;
    }
    
    public abstract Object getContent();
    
    @Override
    public boolean equals(Object o) {
        if (o != null && o instanceof RefAddr) {
            RefAddr refAddr = (RefAddr)o;
            if (this.addrType.compareTo(refAddr.addrType) == 0) {
                Object content = this.getContent();
                Object content2 = refAddr.getContent();
                if (content == content2) {
                    return true;
                }
                if (content != null) {
                    return content.equals(content2);
                }
            }
        }
        return false;
    }
    
    @Override
    public int hashCode() {
        return (this.getContent() == null) ? this.addrType.hashCode() : (this.addrType.hashCode() + this.getContent().hashCode());
    }
    
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer("Type: " + this.addrType + "\n");
        sb.append("Content: " + this.getContent() + "\n");
        return sb.toString();
    }
}
